﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using System.Collections.ObjectModel;
using System.Data;

namespace XamDataGridEditWholeField
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<Record> TempRecords { get; set; }
        public MainWindow()
        {
            InitializeComponent();
            TempRecords = new ObservableCollection<Record>();
        }

        private void xamDataGrid1_SelectedItemsChanged(object sender, Infragistics.Windows.DataPresenter.Events.SelectedItemsChangedEventArgs e)
        {            
            if (e.Type == typeof(DataRecord))
            {
                TempRecords.Clear();
                foreach (var item in xamDataGrid1.SelectedItems.Records)
                {
                    TempRecords.Add(item);
                }
            }
        }

        private void xamDataGrid1_EditModeStarting(object sender, Infragistics.Windows.DataPresenter.Events.EditModeStartingEventArgs e)
        {
            if (TempRecords.Count > 1)
            {
                foreach (var item in TempRecords)
                {
                    xamDataGrid1.SelectedItems.Records.Add(item);
                }
            }            
        }

        private void xamDataGrid1_EditModeEnded(object sender, Infragistics.Windows.DataPresenter.Events.EditModeEndedEventArgs e)
        {
            Dispatcher.BeginInvoke(new Action(() => 
            {
                foreach (var item in xamDataGrid1.SelectedItems.Records)
                {
                    (item as DataRecord).Cells[e.Cell.Field.Name].Value = e.Cell.Value;
                }
                xamDataGrid1.ExecuteCommand(DataPresenterCommands.CommitChangesToAllRecords);
            }), System.Windows.Threading.DispatcherPriority.Background, null);            
        }
    }
}
